/* fsm may 30 2005 s */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.colorchooser.*;

public class colorchooser
	extends JDialog
{
	private JButton choosebutton, okbutton, cancelbutton;
	private JComboBox mycombobox;

	private Color[] origcolors, colors;

	public colorchooser(Component parent, Color[] colors)
	{
		super((Frame)parent, true);

		if (colors != null && colors.length > 0 && colors[0] != null)
		{
			this.origcolors = colors;

//			this.colors = origcolors.clone();
			this.colors = new Color[colors.length];
			for (int i = 0; i < colors.length; i++)
				this.colors[i] = new Color(colors[i].getRGB());

			make_window();
			register_events();

			setLocationRelativeTo(parent);
			setResizable(false);

			show();
		}
		else
		{
			JOptionPane.showMessageDialog(getInstance(),
				"An error occured when choosing colors.\n",
//				+ "colors: " + (colors == null ? "null" : "ok") + "\n"
//				+ "length: " + (colors != null ? colors.length : "null") + "\n"
//				+ "zero: " + (colors != null && colors[0] != null ? colors[0] : "null"),
				"choose color", JOptionPane.PLAIN_MESSAGE);
		}
	}

	public Color[] getColors()
	{
		return origcolors;
	}

	private void make_window()
	{
		Container window;
		JPanel panel, options, buttons;
		JLabel setlabel;
		int i;

		/* create controls */
		setlabel = new JLabel("Set:");

		mycombobox = new JComboBox();
		for (i = 0; i < origcolors.length; i++)
			mycombobox.addItem("" + i);

		choosebutton = new JButton("Choose");

		okbutton = new JButton("Ok");
		cancelbutton = new JButton("Cancel");

		/* create option part */
		options = new JPanel();
		options.setLayout(new FlowLayout());
		options.add(setlabel);
		options.add(mycombobox);
		options.add(choosebutton);

		/* create ok/cancel part */
		buttons = new JPanel();
		buttons.setLayout(new FlowLayout());
		buttons.add(okbutton);
		buttons.add(cancelbutton);

		/* add everything to the window */
		panel = new JPanel();
		panel.setLayout(new BorderLayout());
		panel.add(options, BorderLayout.CENTER);
		panel.add(buttons, BorderLayout.SOUTH);

		window = getContentPane();
		window.add(panel);

		setTitle("color chooser");
		pack();
	}

	private void register_events()
	{
		ActionEventHandler myactionlistener;

		/* window close event. seems to do the opposite of what we want
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		*/

		/* button events */
		myactionlistener = new ActionEventHandler();
		choosebutton.addActionListener(myactionlistener);
		okbutton.addActionListener(myactionlistener);
		cancelbutton.addActionListener(myactionlistener);
	}

	private Component getInstance()
	{
		return this;
	}

	private class ActionEventHandler
		implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{
			Object obj = e.getSource();

			if (obj == choosebutton)
			{
				Color c;
				int i = mycombobox.getSelectedIndex();

				c = JColorChooser.showDialog(getInstance(), "color chooser", colors[i]);
				if (c != null)
					colors[i] = c;
			}
			else if (obj == okbutton)
			{
				/* do it this way so the window's x button doesn't change anything */
				origcolors = colors;

				hide();
			}
			else if (obj == cancelbutton)
			{
				hide();
			}
		}
	}
}

